"""
Author: Ari Ugarte
"""

#METACLADE INI OPTIONS AND DEFAULT VALUES
PROGRAM_SECTION                   = "Programs"
PROGRAM_PATHS_PSIBLAST_DIR        = "PSIBLAST_DIR"
PROGRAM_PATHS_HMMER_DIR           = "HMMER_DIR"
MODEL_SECTION                     = "Models"
MODELS_PSSMS_DIR                  = "PSSMS_DIR"
MODELS_PSSMS_DIR_DEFAULT          = "%s/data/models/pssms/"
MODELS_CCM_BREAKS_DIR             = "CCM_BREAKS_DIR"
MODELS_CCM_BREAKS_DIR_DEFAULT     = "%s/data/models/ccm_breaks/"
MODELS_HMMS_DIR                   = "HMMS_DIR"
MODELS_HMMS_DIR_DEFAULT           = "%s/data/models/hmms/"
MODELS_SCM_BREAKS_DIR             = "SCM_BREAKS_DIR"
MODELS_SCM_BREAKS_DIR_DEFAULT     = "%s/data/models/scm_breaks/"
DOMAINS_SECTION                   = "Domains"
DOMAINS_LIST                      = "DOMAINS_LIST"
DOMAINS_LIST_DEFAULT              = "%s/data/pfamLists/models_in_acc.txt"
RUNENV_SECTION                    = "RunEnv"
RUNENV_TMP_DIR                    = "TMP_DIR"
RUNENV_TMP_DIR_DEFAULT            = "%s/data/tmp/"
RUNENV_MODEL_LIST                 = "MODEL_LIST"
RUNENV_MODEL_LIST_DEFAULT         = "%s/data/pfamLists/used/%s/list.txt.final"
RUNENV_BASE_DIR                   = "BASE_DIR"
RUNENV_RESULTS_DIR                = "RESULTS_DIR"
RUNENV_RESULTS_DIR_DEFAULT        = "%s/data/results/"
RUNENV_JOBS_DIR                   = "JOBS_DIR"
RUNENV_JOBS_DIR_DEFAULT           = "%s/data/jobs/"
RUNENV_SCRIPTS_DIR                = "SCRIPTS_DIR"
RUNENV_SCRIPTS_DIR_DEFAULT        = "%s/scripts/"
RUNENV_FILES_DIR                  = "FILES_DIR"
RUNENV_FILES_DIR_DEFAULT          = "%s/files/"
RUNENV_PYTHON_PATH                = "PYTHON_PATH"
RUNENV_PYTHON_PATH_DEFAULT        = "python"
METACLADE_CONFIG_SECTIONS         = [PROGRAM_SECTION,MODEL_SECTION,DOMAINS_SECTION,RUNENV_SECTION]

#RUN INI OPTIONS AND DEFAULT VALUES
PARAMETERS_SECTION                = "Parameters"
PARAMETERS_FASTA_FILE             = "FASTA_FILE"
PARAMETERS_DATASET_NAME           = "DATASET_NAME"
PARAMETERS_NUMBER_OF_JOBS         = "NUMBER_OF_JOBS"
PARAMETERS_NUMBER_OF_JOBS_DEFAULT = "1"
PARAMETERS_CREATE_BLASTDB         = "CREATE_BLASTDB"
PARAMETERS_CREATE_BLASTDB_DEFAULT = "False"
PARAMETERS_SEARCH                 = "SEARCH"
PARAMETERS_SEARCH_DEFAULT         = "True"
PARAMETERS_SAME_OL_FILTER         = "SAME_OL_FILTER"
PARAMETERS_SAME_OL_FILTER_DEFAULT = "True"
PARAMETERS_NB_FILTER              = "NB_FILTER"
PARAMETERS_NB_FILTER_DEFAULT      = "True"
PARAMETERS_NB_THRESHOLD           = "NB_THRESHOLD"
PARAMETERS_NB_THRESHOLD_DEFAULT   = "0.9"
PARAMETERS_ALL_OL_FILTER          = "ALL_OL_FILTER"
PARAMETERS_ALL_OL_FILTER_DEFAULT  = "True"

#BLAST SCRIPTS AND PARAMETERS
BLAST_MAKEBLASTDB                 = "makeblastdb"
BLAST_IN                          = "-in"
BLAST_DBTYPE                      = "-dbtype"
BLAST_PROT                        = "prot"

#MCLADE SCRIPTS
HMMER_SCRIPT                      = "hmmer.py"
PSSMS_SCRIPT                      = "pssms.py"
OL_FILTER_SCRIPT                  = "parse_output.py"
NB_EVAL_SCRIPT                    = "evaluate_attributes_mclade.py"
NB_FILTER_SCRIPT                  = "filter_nb_results.py"
ALL_OV_SCRIPT                     = "final_prediction.py"

#MODEL SEARCH
SEARCH_DIR_NAME                   = "model_search"
SEARCH_OUTPUT_DIR_NAME            = "models_output"
CCM_SEARCH_RES_EXT                = ".res"
SCM_SEARCH_RES_EXT                = ".domtblout"
CCM_ZIP_EXT                       = ".tar.gz"
CCM_EXT                           = ".chk"
SCM_EXT                           = ".hmm"

#ARFF AND BEST DOMAINS GENERATION
ARFF_JOB_DIR_NAME                 = "arff_files"
ARFF_RESULT_DIR_NAME              = "arff_files"
NB_JOB_DIR_NAME                   = "mclade_eval"
NB_RESULT_DIR_NAME                = "mclade_eval"
BD_JOB_DIR_NAME                   = "best_domains"
BD_RESULT_DIR_NAME                = "best_domains"
NB_FILTER_OUT_FILE                = "best_domains.mclade"
FP_JOB_DIR_NAME                   = "final_prediction"
FP_RESULT_DIR_NAME                = "final_prediction"
FINAL_PREDICTION_OUT_FILE         = "final_prediction.mclade"

CCM_ARFF_RES_EXT                  = ".ccm.arff"
SCM_ARFF_RES_EXT                  = ".scm.arff"
CCM_RESULT_RESUME                 = "result_resume.ccm.best"
SCM_RESULT_RESUME                 = "result_resume.scm.best"

#NB EVALUATION
CCM_EVAL_RES_EXT                  = ".ccm.arff.res"
SCM_EVAL_RES_EXT                  = ".scm.arff.res"

MIN_NEG_CCM                       = "min_neg_ccm.dict"
MIN_NEG_SCM                       = "min_neg_scm.dict"
MIN_POS_CCM                       = "min_pos_ccm.dict"
MIN_POS_SCM                       = "min_pos_scm.dict"


#OTHER CONSTANTS
OUT_DIR_NAME                      = "out"
QSUB_SCRIPT_NAME                  = "submit"
SCRIPT_EXT                        = ".sh"
QSUB_LINE                         = "qsub -S /bin/bash -N %s_%d -e %s -o %s %s_%d%s\n"
STR_TRUE                          = "true"
STR_FALSE                         = "false"
PSSMS_MODELS_DICT                 = "models_dict.txt"

#ERROR MESSAGES
INPUT_ERROR_MCLADE_CONFIG         = "Input Error: MetaCLADE config file not found"
INPUT_ERROR_DATASET_CONFIG        = "Input Error: Dataset config file not found"

CONTROLLER_DESCRIPTION            = "This script creates MetaCLADE run files from config (ini) files"
CONTROLLER_ERROR                  = "MetaCLADE Error: \n%s"
MC_INI                            = "MC_ini"
MC_INI_HELP                       = "ini file for MetaCLADE"
RUN_INI                           = "Run_ini"
RUN_INI_HELP                      = "ini file for the dataset"
